# Class PVector3I<T>

java.lang.Object
com.io7m.jtensors.core.parameterized.vectors.PVector3I<T>

Type Parameters:
  `T` - A phantom type parameter

All Implemented Interfaces:
  `PVector3IType<T>, PVectorReadable2IType<T>, PVectorReadable3IType<T>, VectorReadable2IType, VectorReadable3IType, VectorComputationalType`

public final class PVector3I<T> extends Object implements PVector3IType<T>
The type of 3D `int`-typed vectors.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `PVector3I.Builder<T>`
  Builds instances of type `PVector3I`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static <T> PVector3I.Builder<T>`
  `builder()`
  Creates a builder for `PVector3I`.
  `static <T> PVector3I<T>`
  `copyOf(PVector3IType<T> instance)`
  Creates an immutable copy of a `PVector3IType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `PVector3I` that have equal attribute values.
  `int`
  `hashCode()`
  Computes a hash code from attributes: `x`, `y`, `z`.
  `static <T> PVector3I<T>`
  `of(int x, int y, int z)`
  Construct a new immutable `PVector3I` instance.
  `String`
  `toString()`
  Prints the immutable value `PVector3I` with attribute values.
  `final PVector3I<T>`
  `withX(int value)`
  Copy the current immutable object by setting a value for the `x` attribute.
  `final PVector3I<T>`
  `withY(int value)`
  Copy the current immutable object by setting a value for the `y` attribute.
  `final PVector3I<T>`
  `withZ(int value)`
  Copy the current immutable object by setting a value for the `z` attribute.
  `int`
  `x()`
  `int`
  `y()`
  `int`
  `z()`

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### x

    public int x()
    Specified by:
      `x` in interface `PVector3IType<T>`
    Specified by:
      `x` in interface `VectorReadable2IType`
    Returns:
      The value of the `x` attribute

  - ### y

    public int y()
    Specified by:
      `y` in interface `PVector3IType<T>`
    Specified by:
      `y` in interface `VectorReadable2IType`
    Returns:
      The value of the `y` attribute

  - ### z

    public int z()
    Specified by:
      `z` in interface `PVector3IType<T>`
    Specified by:
      `z` in interface `VectorReadable3IType`
    Returns:
      The value of the `z` attribute

  - ### withX

    public final PVector3I<T> withX(int value)
    Copy the current immutable object by setting a value for the `x` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for x
    Returns:
      A modified copy or the `this` object

  - ### withY

    public final PVector3I<T> withY(int value)
    Copy the current immutable object by setting a value for the `y` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for y
    Returns:
      A modified copy or the `this` object

  - ### withZ

    public final PVector3I<T> withZ(int value)
    Copy the current immutable object by setting a value for the `z` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for z
    Returns:
      A modified copy or the `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `PVector3I` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `x`, `y`, `z`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `PVector3I` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### of

    public static <T> PVector3I<T> of(int x, int y, int z)
    Construct a new immutable `PVector3I` instance.
    Type Parameters:
      `T` - generic parameter T
    Parameters:
      `x` - The value for the `x` attribute
      `y` - The value for the `y` attribute
      `z` - The value for the `z` attribute
    Returns:
      An immutable PVector3I instance

  - ### copyOf

    public static <T> PVector3I<T> copyOf(PVector3IType<T> instance)
    Creates an immutable copy of a `PVector3IType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Type Parameters:
      `T` - generic parameter T
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable PVector3I instance

  - ### builder

    public static <T> PVector3I.Builder<T> builder()
    Creates a builder for `PVector3I`.

        PVector3I.<T>builder()
           .setX(int) // required x
           .setY(int) // required y
           .setZ(int) // required z
           .build();

    Type Parameters:
      `T` - generic parameter T
    Returns:
      A new PVector3I builder